Index: FL/Fl.H
===================================================================
--- FL/Fl.H	(revision 9336)
+++ FL/Fl.H	(working copy)
@@ -128,6 +130,8 @@
   static int e_y_root;
   static int e_dx;
   static int e_dy;
+  static int e_dxy_timespan; //milliseconds
+  static int e_timestamp; //milliseconds
   static int e_state;
   static int e_clicks;
   static int e_is_click;
@@ -598,6 +603,10 @@
   static int event_state()	{return e_state;}
   /** See int event_state() */
   static int event_state(int i) {return e_state&i;}
+  
+  static int event_timestamp() {return e_timestamp;} //milisecond timestamp
+  static int getMilliCount(); //return millisecond timestamp
+  static int getMilliSpan(int nTimeStart); //return millisecond timespan
   /**
     Gets which key on the keyboard was last pushed.
 
Index: src/Fl.cxx
===================================================================
--- src/Fl.cxx	(revision 9336)
+++ src/Fl.cxx	(working copy)
@@ -103,9 +103,10 @@
 		Fl::scrollbar_size_ = 16;
 
 char		*Fl::e_text = (char *)"";
-int		Fl::e_length;
+int		Fl::e_length, Fl::e_timestamp = 0, Fl::e_dxy_timespan = 0;
 
@@ -209,6 +210,20 @@
   return (mx >= 0 && mx < o->w() && my >= 0 && my < o->h());
 }
 
+#include <sys/timeb.h>
+int Fl::getMilliCount(){
+	timeb tb;
+	ftime(&tb);
+	int nCount = tb.millitm + (tb.time & 0xfffff) * 1000;
+	return nCount;
+}
+
+int Fl::getMilliSpan(int nTimeStart){
+	int nSpan = getMilliCount() - nTimeStart;
+	if(nSpan < 0)
+		nSpan += 0x100000 * 1000;
+	return nSpan;
+}
 //
 //
 // timer support
@@ -1158,7 +1174,7 @@
 #ifdef DEBUG
     printf("Fl::handle(e=%d, window=%p);\n", e, window);
 #endif // DEBUG
-
+	e_timestamp = getMilliCount();
     if (grab()) wi = grab();
     else if (modal() && wi != modal()) return 0;
     pushed_ = wi;
@@ -1223,7 +1239,7 @@
   case FL_RELEASE: {
 //    printf("FL_RELEASE: window=%p, pushed() = %p, grab() = %p, modal() = %p\n",
 //           window, pushed(), grab(), modal());
-
+	e_timestamp = getMilliCount();
     if (grab()) {
       wi = grab();
       pushed_ = 0; // must be zero before callback is done!
@@ -1262,7 +1278,7 @@
 #endif // DEBUG
 
     Fl_Tooltip::enter((Fl_Widget*)0);
-
+	e_timestamp = getMilliCount();
     fl_xfocus = window; // this should not happen!  But maybe it does:
 
     // Try it as keystroke, sending it to focus and all parents:
@@ -1330,6 +1346,10 @@
     return 1;
 
   case FL_MOUSEWHEEL:
+	e_dxy_timespan = getMilliSpan(e_timestamp);
+	e_timestamp = getMilliCount();
+	//printf("e_dxy_timespan : %d : %d : %d : %d\n", e_dxy_timespan, e_dx, e_dy, e_number);
+	if(e_dxy_timespan < 50) e_dy *= (50-e_dxy_timespan)/5;
     fl_xfocus = window; // this should not happen!  But maybe it does:
 
     // Try sending it to the "grab" first